cookutils view cook @ rev 255

cook: remove .hg dir when clonig from Hg
author Christophe Lincoln <pankso@slitaz.org>
date Sun May 29 04:14:18 2011 +0200 (2011-05-29)
parents 93cb8f6fb98c
children 2db13a8fe9b4
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifing any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
11 [ -f "cook.conf" ] && . ./cook.conf
13 # Share DB and status with the Cooker.
14 activity="$CACHE/activity"
15 command="$CACHE/command"
16 broken="$CACHE/broken"
17 blocked="$CACHE/blocked"
19 # Old style compatibility
20 SOURCES_REPOSITORY=$SRC
22 #
23 # Functions
24 #
26 usage() {
27 cat << EOT
29 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
31 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
32 usage|help $(gettext "Display this short usage.")
33 setup $(gettext "Setup your build environment.")
34 test $(gettext "Test environment and cook a package.")
35 list-wok $(gettext "List packages in the wok.")
36 search $(gettext "Simple packages search function.")
37 new $(gettext "Create a new package with a receipt".)
38 list $(gettext "Cook a list of packages.")
39 clean-wok $(gettext "Clean-up all packages files.")
40 clean-src $(gettext "Clean-up all packages sources.")
41 pkgdb $(gettext "Create packages DB lists and flavors.")
43 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
44 --clean|-c Cook : $(gettext "clean the package in the wok.")
45 --install|-i Cook : $(gettext "cook and install the package.")
46 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
47 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
48 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
49 --interactive|-x New : $(gettext "create a receipt interactively.")
50 --wok|-w Setup: $(gettext "clone the cooking wok from Hg repo.")
51 --stable Setup: $(gettext "clone the stable wok from Hg repo.")
52 --undigest Setup: $(gettext "clone the undigest wok from Hg repo.")
53 --flavors Pkgdb: $(gettext "create up-to-date flavors files.")
55 EOT
56 exit 0
57 }
59 # Be sure we're root.
60 check_root() {
61 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
62 }
64 separator() {
65 echo "================================================================================"
66 }
68 status() {
69 echo -en "\\033[70G[ "
70 if [ $? = 0 ]; then
71 echo -en "\\033[1;32mOK"
72 else
73 echo -en "\\033[1;31mFailed"
74 fi
75 echo -e "\\033[0;39m ]"
76 }
78 # Log activities, we want first letter capitalized.
79 log() {
80 grep ^[A-Z] | \
81 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
82 }
84 # We don't want these escapes in web interface.
85 clean_log() {
86 sed -i -e s'|\[70G\[ \[1;32m| |' \
87 -e s'|\[0;39m \]||' $LOGS/$pkg.log
88 }
90 # Log broken packages.
91 broken() {
92 if ! grep -q "^$pkg$" $broken; then
93 echo "$pkg" >> $broken
94 fi
95 }
97 # Be sure package exists in wok.
98 check_pkg_in_wok() {
99 if [ ! -d "$WOK/$pkg" ]; then
100 gettext -e "\nUnable to find package in the wok:"
101 echo -e " $pkg\n" && exit 1
102 fi
103 }
105 if_empty_value() {
106 if [ -z "$value" ]; then
107 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
108 exit 1
109 fi
110 }
112 # Initialize files used in $CACHE
113 init_db_files() {
114 gettext "Creating directories structure in:"; echo " $SLITAZ"
115 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
116 gettext "Creating DB files in:"; echo " $CACHE"
117 for f in $activity $command $broken $blocked
118 do
119 touch $f
120 done
121 }
123 # QA: check a receipt consistency before building.
124 receipt_quality() {
125 gettext -e "QA: checking package receipt...\n"
126 unset online
127 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
128 online="online"
129 fi
130 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
131 do
132 unset value
133 value=$(grep ^$var= $receipt | cut -d \" -f 2)
134 case "$var" in
135 PACKAGE|VERSION|SHORT_DESC)
136 if_empty_value ;;
137 CATEGORY)
138 [ -z "$value" ] && value="empty"
139 valid="base-system x-window utilities network graphics \
140 multimedia office development system-tools security games \
141 misc meta non-free"
142 if ! echo "$valid" | grep -q -w "$value"; then
143 gettext "QA: unknown category:"; echo -e " $value\n"
144 exit 1
145 fi ;;
146 WEB_SITE)
147 # We don't check WGET_URL since if dl is needed it will fail.
148 # Break also if we're not online. Here error is not fatal.
149 if_empty_value
150 [ -z "$online" ] || break
151 if ! busybox wget -T 12 -s $value 2>/dev/null; then
152 gettext "QA: Unable to reach:"; echo -e " $value"
153 fi ;;
154 esac
155 done
156 }
158 # Executed before sourcing a receipt.
159 unset_receipt() {
160 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
161 }
163 # Paths used in receipt and by cook itself.
164 set_paths() {
165 pkgdir=$WOK/$PACKAGE
166 src=$pkgdir/source/$PACKAGE-$VERSION
167 taz=$pkgdir/taz
168 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
169 fs=$pack/fs
170 stuff=$pkgdir/stuff
171 install=$pkgdir/install
172 if [ "$WANTED" ]; then
173 src=$WOK/$WANTED/source/$WANTED-$VERSION
174 install=$WOK/$WANTED/install
175 wanted_stuff=$WOK/$WANTED/stuff
176 fi
177 # Kernel version is set from linux-api-headers since it is part of toolchain.
178 if [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
179 kvers=$(grep ^VERSION= $INSTALLED/linux-api-headers/receipt | cut -d '"' -f 2)
180 fi
181 # Old way compatibility.
182 _pkg=$install
183 }
185 # Create source tarball when URL is a SCM.
186 create_tarball() {
187 gettext "Creating tarball: "; echo "$tarball"
188 if [ "$LZMA_SRC" ]; then
189 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
190 else
191 tar cjf $tarball $pkgsrc || exit 1
192 mv $tarball $SRC && rm -rf $pkgsrc
193 fi
194 }
196 # Get package source. For SCM we are in cache so clone here and create a
197 # tarball here.
198 get_source() {
199 pwd=$(pwd)
200 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
201 tarball=$pkgsrc.tar.bz2
202 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
203 case "$WGET_URL" in
204 http://*|ftp://*)
205 # Busybox Wget is better!
206 busybox wget -T 12 -c -O $SRC/$TARBALL $WGET_URL || \
207 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
208 https://*)
209 wget -c --no-check-certificate -O $SRC/$TARBALL $WGET_URL || \
210 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
211 hg*|mercurial*)
212 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
213 url=${WGET_URL#hg|}
214 else
215 url=${WGET_URL#mercurial|}
216 fi
217 gettext -e "Getting source from Hg...\n"
218 echo "URL: $url"
219 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
220 if [ "$BRANCH" ]; then
221 echo "Hg branch: $BRANCH"
222 hg clone $url --rev $BRANCH $pkgsrc || \
223 (echo "ERROR: hg clone $url --rev $BRANCH" && exit 1)
224 else
225 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
226 fi
227 rm -rf $pkgsrc/.hg
228 create_tarball ;;
229 git*)
230 url=${WGET_URL#git|}
231 gettext -e "Getting source from Git...\n"
232 echo "URL: $url"
233 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
234 if [ "$BRANCH" ]; then
235 echo "Git branch: $BRANCH"
236 cd $pkgsrc && git checkout $BRANCH && cd ..
237 fi
238 create_tarball ;;
239 cvs*)
240 url=${WGET_URL#cvs|}
241 mod=$PACKAGE
242 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
243 gettext -e "Getting source from CVS...\n"
244 echo "URL: $url"
245 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
246 gettext "Cloning to: "; echo "$pwd/$mod"
247 cvs -d:$url co $mod && mv $mod $pkgsrc
248 create_tarball ;;
249 svn*|subversion*)
250 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
251 url=${WGET_URL#svn|}
252 else
253 url=${WGET_URL#subversion|}
254 fi
255 gettext -e "Getting source from SVN...\n"
256 echo "URL: $url"
257 if [ "$BRANCH" ]; then
258 echo t | svn co $url -r $BRANCH $pkgsrc
259 else
260 echo t | svn co $url $pkgsrc
261 fi
262 create_tarball ;;
263 *)
264 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
265 tee -a $LOGS/$PACKAGE.log
266 exit 1 ;;
267 esac
268 }
270 # Extract source package.
271 extract_source() {
272 if [ ! -s "$SRC/$TARBALL" ]; then
273 local url
274 url="http://mirror.slitaz.org/sources/packages"
275 url=$url/${TARBALL:0:1}/$TARBALL
276 gettext "Getting source from mirror:"; echo " $url"
277 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
278 fi
279 gettext "Extracting:"; echo " $TARBALL"
280 case "$TARBALL" in
281 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
282 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
283 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
284 *.tar) tar xf $SRC/$TARBALL ;;
285 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
286 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
287 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
288 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
289 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
290 *) cp $SRC/$TARBALL $(pwd) ;;
291 esac
292 }
294 # Display cooked package summary.
295 summary() {
296 cd $WOK/$pkg
297 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
298 fs=$(du -sh taz/* | awk '{print $1}')
299 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
300 files=$(cat taz/$pkg-*/files.list | wc -l)
301 cookdate=$(date "+%Y-%m-%d %H:%M")
302 sec=$time
303 div=$(($time / 60))
304 [ "$div" != 0 ] && min="~ ${div}m"
305 gettext "Summary for:"; echo " $PACKAGE $VERSION"
306 separator
307 [ "$prod" ] && echo "Produced : $prod"
308 cat << EOT
309 Packed : $fs
310 Compressed : $size
311 Files : $files
312 Cook time : ${sec}s $min
313 Cook date : $cookdate
314 $(separator)
315 EOT
316 }
318 # Display debugging error info.
319 debug_info() {
320 echo -e "\nDebug information"
321 separator
322 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
323 for error in \
324 ERROR "No package" "cp: can't" "can't open" "can't cd" \
325 "error:" "fatal error:"
326 do
327 fgrep "$error" $LOGS/$pkg.log
328 done
329 separator && echo ""
330 }
332 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
333 # so some packages need to copy these files with the receipt and genpkg_rules.
334 copy_generic_files()
335 {
336 # $LOCALE is set in cook.conf
337 if [ "$LOCALE" ]; then
338 if [ -d "$_pkg/usr/share/locale" ]; then
339 mkdir -p $fs/usr/share/locale
340 for i in $LOCALE
341 do
342 if [ -d "$_pkg/usr/share/locale/$i" ]; then
343 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
344 fi
345 done
346 fi
347 fi
349 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
350 if [ "$GENERIC_PIXMAPS" != "no" ]; then
351 if [ -d "$_pkg/usr/share/pixmaps" ]; then
352 mkdir -p $fs/usr/share/pixmaps
353 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
354 $fs/usr/share/pixmaps 2>/dev/null
355 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
356 $fs/usr/share/pixmaps 2>/dev/null
357 fi
359 # Custom or homemade PNG pixmap can be in stuff.
360 if [ -f "$stuff/$PACKAGE.png" ]; then
361 mkdir -p $fs/usr/share/pixmaps
362 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
363 fi
364 fi
366 # Desktop entry (.desktop).
367 if [ -d "$_pkg/usr/share/applications" ]; then
368 cp -a $_pkg/usr/share/applications $fs/usr/share
369 fi
371 # Homemade desktop file(s) can be in stuff.
372 if [ -d "$stuff/applications" ]; then
373 mkdir -p $fs/usr/share
374 cp -a $stuff/applications $fs/usr/share
375 fi
376 if [ -f "$stuff/$PACKAGE.desktop" ]; then
377 mkdir -p $fs/usr/share/applications
378 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
379 fi
380 }
382 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
383 # as removing uneeded files like in Python packages.
384 strip_package()
385 {
386 gettext "Executing strip on all files..."
387 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
388 do
389 if [ -d "$dir" ]; then
390 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
391 fi
392 done
393 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
394 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
395 status
397 # Remove Python .pyc and .pyo from packages.
398 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
399 gettext "Removing Python compiled files..."
400 find $fs -type f -name "*.pyc" -delete 2>/dev/null
401 find $fs -type f -name "*.pyo" -delete 2>/dev/null
402 status
403 fi
405 # Remove Perl perllocal.pod and .packlist from packages.
406 if echo "$DEPENDS" | fgrep -q "perl"; then
407 gettext "Removing Perl compiled files..."
408 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
409 find $fs -type f -name ".packlist" -delete 2>/dev/null
410 status
411 fi
412 }
414 # Remove installed deps.
415 remove_deps() {
416 # Now remove installed build deps.
417 diff="$CACHE/installed.cook.diff"
418 if [ -s "$CACHE/installed.cook.diff" ]; then
419 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
420 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
421 gettext "Build dependencies to remove:"; echo " $nb"
422 gettext "Removing:"
423 for dep in $deps
424 do
425 echo -n " $dep"
426 echo 'y' | tazpkg remove $dep >/dev/null
427 done
428 echo -e "\n"
429 # Keep the last diff for debug and info.
430 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
431 fi
432 }
434 # The main cook function.
435 cookit() {
436 echo "Cook: $PACKAGE $VERSION"
437 separator
438 set_paths
439 [ "$QA" ] && receipt_quality
440 cd $pkgdir
441 rm -rf install taz source
443 # Disable -pipe if less than 512Mb free RAM.
444 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
445 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
446 gettext -e "Disabling -pipe compile flag: $free RAM\n"
447 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
448 CXXFLAGS="${CXXFLAGS/-pipe}" && \
449 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
450 fi
451 unset free
453 # Export flags and path to be used by make and receipt.
454 DESTDIR=$pkgdir/install
455 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
457 # Check for build deps and handle implicit depends of *-dev packages
458 # (ex: libusb-dev :: libusb).
459 rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
460 touch $CACHE/installed.local $CACHE/installed.web
461 [ "$BUILD_DEPENDS" ] && gettext -e "Checking build dependencies...\n"
462 for dep in $BUILD_DEPENDS
463 do
464 implicit=${dep%-dev}
465 for i in $dep $implicit
466 do
467 if [ ! -f "$INSTALLED/$i/receipt" ]; then
468 # Try local package first. In some cases implicit doesn't exist, ex:
469 # libboost-dev exists but not libboost, so check if we got vers.
470 unset vers
471 vers=$(grep ^VERSION= $WOK/$i/receipt 2>/dev/null | cut -d '"' -f 2)
472 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
473 echo $i-$vers.tazpkg >> $CACHE/installed.local
474 else
475 # Priority to package version in wok (maybe more up-to-date)
476 # than the mirrored one.
477 if [ "$vers" ]; then
478 if fgrep -q $i-$vers $DB/packages.list; then
479 echo $i >> $CACHE/installed.web
480 else
481 # So package exists in wok but not available.
482 gettext "Missing dep (wok/pkg):"; echo " $i $vers"
483 echo $i >> $CACHE/missing.dep
484 fi
485 else
486 # Package is not in wok but may be in repo.
487 if fgrep -q $i-$vers $DB/packages.list; then
488 echo $i >> $CACHE/installed.web
489 else
490 echo "ERROR: unknown dep $i" && exit 1
491 fi
492 fi
493 fi
494 fi
495 done
496 done
498 # Get the list of installed packages
499 cd $INSTALLED && ls -1 > $CACHE/installed.list
501 # Have we a missing build dep to cook ?
502 if [ -s "$CACHE/missing.dep" ] && [ "$AUTO_COOK" ]; then
503 gettext -e "Auto cook config is set : AUTO_COOK\n"
504 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
505 for i in $(uniq $CACHE/missing.dep)
506 do
507 (gettext "Building dep (wok/pkg) :"; echo " $i $vers") | \
508 tee -a $LOGS/$PACKAGE.log.$$
509 cook $i || (echo -e "ERROR: can't cook dep '$i'\n" && \
510 fgrep "remove: " $LOGS/$i.log && \
511 fgrep "Removing: " $LOGS/$i.log && echo "") | \
512 tee -a $LOGS/$PACKAGE.log.$$ && break
513 done
514 rm -f $CACHE/missing.dep
515 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
516 fi
518 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
519 # is enabled and cook fails we have ERROR in log, if no auto cook we have
520 # missing dep in cached file.
521 if fgrep -q "ERROR:" $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
522 [ -s "$CACHE/missing.dep" ] && nb=$(cat $CACHE/missing.dep | wc -l)
523 echo "ERROR: missing dep $nb" && exit 1
524 fi
526 # Install local packages.
527 cd $PKGS
528 for i in $(uniq $CACHE/installed.local)
529 do
530 gettext "Installing dep (pkg/local):"; echo " $i"
531 tazpkg install $i >/dev/null
532 done
534 # Install web or cached packages (if mirror is set to $PKGS we only
535 # use local packages).
536 for i in $(uniq $CACHE/installed.web)
537 do
538 gettext "Installing dep (web/cache):"; echo " $i"
539 tazpkg get-install $i >/dev/null
540 done
542 # If a cook failed deps are removed.
543 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
544 [ ! -s "installed.cook.diff" ] && \
545 busybox diff installed.list installed.cook > installed.cook.diff
546 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
548 # Get source tarball and make sure we have source dir named:
549 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
550 # tarball if it exists.
551 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
552 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
553 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
554 LZMA_SRC=""
555 else
556 get_source || exit 1
557 fi
558 fi
559 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
560 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
561 extract_source || exit 1
562 if [ "$LZMA_SRC" ]; then
563 cd $pkgdir/source
564 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
565 mv tmp tmp-1 && mkdir tmp
566 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
567 fi
568 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
569 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
570 fi
571 fi
572 cd $pkgdir/source/tmp
573 # Some archives are not well done and don't extract to one dir (ex lzma).
574 files=$(ls | wc -l)
575 [ "$files" == 1 ] && [ -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
576 [ "$files" == 1 ] && [ -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
577 mv * ../$PACKAGE-$VERSION/$TARBALL
578 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
579 mv * ../$PACKAGE-$VERSION
580 cd .. && rm -rf tmp
581 fi
583 # Execute receipt rules.
584 if grep -q ^compile_rules $receipt; then
585 gettext -e "Executing: compile_rules\n"
586 [ -d "$src" ] && cd $src
587 compile_rules $@ || exit 1
588 # Stay compatible with _pkg
589 [ -d "$src/_pkg" ] && mv $src/_pkg $install
590 # QA: compile_rules success so valid.
591 mkdir -p $install
592 else
593 # QA: No compile_rules so no error, valid.
594 mkdir -p $install
595 fi
596 separator && echo ""
597 }
599 # Cook quality assurance.
600 cookit_quality() {
601 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
602 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
603 fi
604 # ERROR can be echoed any time in cookit()
605 if fgrep -q ERROR: $LOGS/$pkg.log; then
606 debug_info | tee -a $LOGS/$pkg.log
607 rm -f $command && exit 1
608 fi
609 }
611 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
612 # but it doesn't handle EXTRAVERSION.
613 packit() {
614 set_paths
615 echo "Pack: $PACKAGE $VERSION"
616 separator
617 if grep -q ^genpkg_rules $receipt; then
618 gettext -e "Executing: genpkg_rules\n"
619 cd $pkgdir && mkdir -p $fs
620 genpkg_rules || echo -e "\nERROR: genpkg_rules failed\n" >> \
621 $LOGS/$pkg.log
622 else
623 gettext "No packages rules: meta package"; echo
624 mkdir -p $fs
625 fi
627 # First QA check to stop now if genpkg_rules failed.
628 if fgrep -q ERROR: $LOGS/$pkg.log; then
629 exit 1
630 fi
632 cd $taz
633 for file in receipt description.txt
634 do
635 [ ! -f "../$file" ] && continue
636 gettext "Copying"; echo -n " $file..."
637 cp -f ../$file $pack && chown 0.0 $pack/$file && status
638 done
639 copy_generic_files
641 # Create files.list with redirecting find output.
642 gettext "Creating the list of files..." && cd $fs
643 find . -type f -print > ../files.list
644 find . -type l -print >> ../files.list
645 cd .. && sed -i s/'^.'/''/ files.list
646 status
648 # Strip and stuff files.
649 strip_package
651 # Md5sum of files.
652 gettext "Creating md5sum of files..."
653 while read file; do
654 [ -L "fs$file" ] && continue
655 [ -f "fs$file" ] || continue
656 case "$file" in
657 /lib/modules/*/modules.*|*.pyc) continue ;;
658 esac
659 md5sum "fs$file" | sed 's/ fs/ /'
660 done < files.list > md5sum
661 status
662 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
663 description.txt 2> /dev/null | awk \
664 '{ sz=$1 } END { print sz }')
666 # Build cpio archives.
667 gettext "Compressing the fs... "
668 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
669 rm -rf fs
670 status
671 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
672 md5sum description.txt 2> /dev/null | awk \
673 '{ sz=$1 } END { print sz }')
674 gettext "Updating receipt sizes..."
675 sed -i s/^PACKED_SIZE.*$// receipt
676 sed -i s/^UNPACKED_SIZE.*$// receipt
677 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
678 status
680 # Set extra version.
681 if [ "$EXTRAVERSION" ]; then
682 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
683 sed -i s/^EXTRAVERSION.*$// receipt
684 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
685 status
686 fi
688 # Compress.
689 gettext "Creating full cpio archive... "
690 find . -print | cpio -o -H newc --quiet > \
691 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
692 status
693 gettext "Restoring original package tree... "
694 unlzma -c fs.cpio.lzma | cpio -idm --quiet
695 status
696 rm fs.cpio.lzma && cd ..
698 # QA and give info.
699 tazpkg=$(ls *.tazpkg)
700 packit_quality
701 separator && gettext "Package:"; echo -e " $tazpkg\n"
702 }
704 # Verify package quality and consistency.
705 packit_quality() {
706 #gettext "QA: Checking for broken link..."
707 #link=$(find $fs/usr -type l -follow)
708 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
709 #status
711 # Exit if any error found in log file.
712 if fgrep -q ERROR: $LOGS/$pkg.log; then
713 rm -f $command && exit 1
714 fi
716 gettext "QA: Checking for empty package..."
717 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
718 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
719 echo -e "\nERROR: empty package"
720 rm -f $command && exit 1
721 else
722 # Ls sort by name so the first file is the one we want.
723 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
724 status
725 if [ -f "$old" ]; then
726 echo -n "Removing old: $(basename $old)"
727 rm -f $old && status
728 fi
729 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
730 sed -i /^${pkg}$/d $broken
731 fi
732 }
734 #
735 # Commands
736 #
738 case "$1" in
739 usage|help|-u|-h)
740 usage ;;
741 list-wok)
742 gettext -e "\nList of packages in:"; echo " $WOK"
743 separator
744 cd $WOK && ls -1
745 separator
746 echo -n "Packages: " && ls | wc -l
747 echo "" ;;
748 search)
749 # Just a simple search function, we dont need more actually.
750 query="$2"
751 gettext -e "\nSearch results for:"; echo " $query"
752 separator
753 cd $WOK && ls -1 | grep "$query"
754 separator && echo "" ;;
755 setup)
756 # Setup a build environment
757 check_root
758 echo "Cook: setting up the environment" | log
759 gettext -e "\nSetting up your environment\n"
760 separator && cd $SLITAZ
761 init_db_files
762 gettext -e "Checking for packages to install...\n"
763 for pkg in $SETUP_PKGS
764 do
765 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
766 done
768 # Handle --options
769 case "$2" in
770 --wok|-w)
771 hg clone $WOK_URL wok || exit 1 ;;
772 --stable)
773 hg clone $WOK_URL-stable wok || exit 1 ;;
774 --undigest)
775 hg clone $WOK_URL-undigest wok || exit 1 ;;
776 esac
778 # SliTaz group and permissions
779 if ! grep -q ^slitaz /etc/group; then
780 gettext -e "Adding group: slitaz\n"
781 addgroup slitaz
782 fi
783 gettext -e "Setting permissions for slitaz group...\n"
784 chown -R root.slitaz $SLITAZ
785 chmod -R g+w $SLITAZ
786 separator
787 gettext -e "All done, ready to cook packages :-)\n\n" ;;
788 test)
789 # Test a cook environment.
790 echo "Cook test: testing the cook environment" | log
791 [ ! -d "$WOK" ] && exit 1
792 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
793 cook cooktest ;;
794 new)
795 # Create the package folder and an empty receipt.
796 pkg="$2"
797 [ "$pkg" ] || usage
798 echo ""
799 if [ -d "$WOK/$pkg" ]; then
800 echo -n "$pkg " && gettext "package already exists."
801 echo -e "\n" && exit 1
802 fi
803 gettext "Creating"; echo -n " $WOK/$pkg"
804 mkdir $WOK/$pkg && cd $WOK/$pkg && status
805 gettext "Preparing the package receipt..."
806 cp $DATA/receipt .
807 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
808 status && echo ""
810 # Interactive mode, asking and seding.
811 case "$3" in
812 --interactive|-x)
813 gettext -e "Entering interactive mode...\n"
814 separator
815 echo "Package : $pkg"
816 # Version.
817 echo -n "Version : " ; read anser
818 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
819 # Category.
820 echo -n "Category : " ; read anser
821 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
822 # Short description.
823 echo -n "Short desc : " ; read anser
824 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
825 # Maintainer.
826 echo -n "Maintainer : " ; read anser
827 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
828 # Web site.
829 echo -n "Web site : " ; read anser
830 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
831 echo ""
832 # Wget URL.
833 echo "Wget URL to download source tarball."
834 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
835 echo -n "Wget url : " ; read anser
836 sed -i s#'WGET_URL=\"$TARBALL\"'#"WGET_URL=\"$anser\""# receipt
837 # Ask for a stuff dir.
838 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
839 if [ "$anser" = "y" ]; then
840 echo -n "Creating the stuff directory..."
841 mkdir $WOK/$pkg/stuff && status
842 fi
843 # Ask for a description file.
844 echo -n "Are you going to write a description ? (y/N) : " ; read anser
845 if [ "$anser" = "y" ]; then
846 echo -n "Creating the description.txt file..."
847 echo "" > $WOK/$pkg/description.txt && status
848 fi
849 separator
850 gettext -e "Receipt is ready to use.\n"
851 echo "" ;;
852 esac ;;
853 list)
854 # Cook a list of packages (better use the Cooker since it will order
855 # packages before executing cook).
856 check_root
857 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
858 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
859 echo -e " $2\n" && exit 1
860 echo "Cook list starting: $2" | log
861 for pkg in $(cat $2)
862 do
863 cook $pkg || broken
864 done ;;
865 clean-wok)
866 check_root
867 gettext -e "\nCleaning all packages files..."
868 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
869 status && echo "" ;;
870 clean-src)
871 check_root
872 gettext -e "\nCleaning all packages sources..."
873 rm -rf $WOK/*/source
874 status && echo "" ;;
875 pkgdb)
876 # Create suitable packages list for TazPKG and only for built packages
877 # as well as flavors files for TazLiTo. We dont need logs since we do it
878 # manually to ensure everything is fine before syncing the mirror.
879 case "$2" in
880 --flavors)
881 continue ;;
882 *)
883 [ "$2" ] && PKGS="$2"
884 [ ! -d "$PKGS" ] && \
885 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1 ;;
886 esac
887 time=$(date +%s)
888 flavors=$SLITAZ/flavors
889 live=$SLITAZ/live
890 echo "cook:pkgdb" > $command
891 echo "Cook pkgdb: Creating all packages lists" | log
892 echo ""
893 gettext "Creating lists for: "; echo "$PKGS"
894 separator
895 gettext "Cook pkgdb started: "; date "+%Y-%m-%d %H:%M"
896 cd $PKGS
897 rm -f packages.*
898 gettext -e "Creating: packages.list\n"
899 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
900 gettext -e "Creating: packages.md5\n"
901 md5sum *.tazpkg > $PKGS/packages.md5
902 gettext -e "Creating lists from: "; echo "$WOK"
903 cd $WOK
904 for pkg in *
905 do
906 unset_receipt
907 . $pkg/receipt
908 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
909 # packages.desc lets us search easily in DB
910 cat >> $PKGS/packages.desc << EOT
911 $PACKAGE | ${VERSION}$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
912 EOT
913 # packages.txt used by tazpkg and tazpkg-web also to provide
914 # a human readable package list with version and description.
915 cat >> $PKGS/packages.txt << EOT
916 $PACKAGE
917 ${VERSION}$EXTRAVERSION
918 $SHORT_DESC
919 $PACKED_SIZE ($UNPACKED_SIZE installed)
921 EOT
922 # packages.equiv is used by tazpkg install to check depends.
923 for i in $PROVIDE; do
924 DEST=""
925 echo $i | fgrep -q : && DEST="${i#*:}:"
926 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
927 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
928 $PKGS/packages.equiv
929 else
930 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
931 fi
932 done
933 # files.list provides a list of all packages files.
934 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
935 $PKGS/files.list
936 fi
937 done
939 # Display list size.
940 gettext -e "Done: packages.desc\n"
941 gettext -e "Done: packages.txt\n"
942 gettext -e "Done: packages.equiv\n"
944 # files.list.lzma
945 gettext -e "Creating: files.list.lzma\n"
946 cd $PKGS && lzma e files.list files.list.lzma
947 rm -f files.list
949 # Display some info.
950 separator
951 nb=$(ls $PKGS/*.tazpkg | wc -l)
952 time=$(($(date +%s) - $time))
953 echo -e "Packages: $nb - Time: ${time}s\n"
955 # Create all flavors files at once. Do we really need code to monitor
956 # flavors changes ? Lets just build them with packages lists before
957 # syncing the mirror.
958 [ "$2" == "--flavors" ] || exit 1
959 [ ! -d "$flavors" ] && echo -e "Missing flavors: $flavors\n" && exit 1
960 [ -d "$live" ] || mkdir -p $live
961 gettext "Creating flavors files in:"; echo " $live"
962 echo "Cook pkgdb: Creating all flavors" | log
963 separator
964 gettext -e "Recharging lists to use latest packages...\n"
965 tazpkg recharge 2>1 >/dev/null
967 # We need a custom tazlito config to set working dir to /home/slitaz.
968 if [ ! -f "$live/tazlito.conf" ]; then
969 echo "Creating configuration file: tazlito.conf"
970 cp /etc/tazlito/tazlito.conf $live
971 sed -i s@WORK_DIR=.*@WORK_DIR=\"/home/slitaz\"@ \
972 $live/tazlito.conf
973 fi
975 # Update Hg flavors repo and pack.
976 [ -d "$flavors/.hg" ] && cd $flavors && hg pull -u
978 cd $live
979 echo "Starting to generate flavors..."
980 rm -f flavors.list *.flavor
981 for i in $flavors/*
982 do
983 fl=$(basename $i)
984 echo "Packing flavor: $(basename $i)"
985 tazlito pack-flavor $fl >/dev/null || exit 1
986 tazlito show-flavor $fl --brief --noheader 2> \
987 /dev/null >> flavors.list
988 done
989 cp -f $live/*.flavor $live/flavors.list $PKGS
990 separator && gettext "Flavors size: "; du -sh $live | awk '{print $1}'
991 echo "" && rm -f $command ;;
992 *)
993 # Just cook and generate a package.
994 check_root
995 time=$(date +%s)
996 pkg="$1"
997 [ -z "$pkg" ] && usage
998 receipt="$WOK/$pkg/receipt"
999 check_pkg_in_wok && echo ""
1001 # Display and log info if cook process stopped.
1002 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
1003 tee -a $LOGS/$pkg.log' INT
1005 # Skip blocked, 3 lines also for the Cooker.
1006 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
1007 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
1008 fi
1010 # Log and source receipt.
1011 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
1012 echo "cook:$pkg" > $command
1013 unset inst
1014 unset_receipt
1015 . $receipt
1017 # Handle --options
1018 case "$2" in
1019 --clean|-c)
1020 gettext -e "Cleaning:"; echo -n " $pkg"
1021 cd $WOK/$pkg && rm -rf install taz source
1022 status && echo "" && exit 0 ;;
1023 --install|-i)
1024 inst='yes' ;;
1025 --getsrc|-gs)
1026 gettext "Getting source for:"; echo " $pkg"
1027 separator && get_source
1028 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
1029 --block|-b)
1030 gettext "Blocking:"; echo -n " $pkg"
1031 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
1032 status && echo "" && exit 0 ;;
1033 --unblock|-ub)
1034 gettext "Unblocking:"; echo -n " $pkg"
1035 sed -i "/^${pkg}$/"d $blocked
1036 status && echo "" && exit 0 ;;
1038 esac
1040 # Check if wanted is built now so we have separate log files.
1041 if [ "$WANTED" ]; then
1042 if grep -q "^$WANTED$" $blocked; then
1043 echo "WANTED package is blocked: $WANTED" | tee $LOGS/$pkg.log
1044 echo "" && rm -f $command && exit 1
1045 fi
1046 if grep -q "^$WANTED$" $broken; then
1047 echo "WANTED package is broken: $WANTED" | tee $LOGS/$pkg.log
1048 echo "" && rm -f $command && exit 1
1049 fi
1050 if [ ! -d "$WOK/$WANTED/install" ]; then
1051 cook "$WANTED" || exit 1
1052 fi
1053 fi
1055 # Cook and pack or exit on error and log everything.
1056 cookit $@ 2>&1 | tee $LOGS/$pkg.log
1057 remove_deps | tee -a $LOGS/$pkg.log
1058 cookit_quality
1059 packit 2>&1 | tee -a $LOGS/$pkg.log
1060 clean_log
1062 # Exit if any error in packing.
1063 if grep -q ^ERROR $LOGS/$pkg.log; then
1064 debug_info | tee -a $LOGS/$pkg.log
1065 rm -f $command && exit 1
1066 fi
1068 # Time and summary
1069 time=$(($(date +%s) - $time))
1070 summary | tee -a $LOGS/$pkg.log
1071 echo ""
1073 # Install package if requested
1074 if [ "$inst" ]; then
1075 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
1076 cd $PKGS && tazpkg install \
1077 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
1078 else
1079 gettext -e "Unable to install package, build has failed.\n\n"
1080 exit 1
1081 fi
1082 fi
1083 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
1084 # You want automation: use the Cooker Build Bot.
1085 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
1086 rm -f $command ;;
1087 esac
1089 exit 0